import { Outlet } from "react-router-dom"
import PublicHeader from "./PublicHeader"
import PublicFooter from "./PublicFooter"
import Basket from "./Basket"
import { useState } from "react"

const LayoutPublic = () => {
    const [isCartOpen, setCartOpen] = useState(false)
    return(
        <>
        <PublicHeader 
            handleCart={()=> setCartOpen(true)}
        />
        <Outlet/>
        <PublicFooter/>
        <Basket 
        cartOpen={isCartOpen}
        closeCart={()=> setCartOpen(false)}
        />
        </>
    )
}

export default LayoutPublic